__author__ = "Keines"
__version__ = "2007.08.29(Wed) 03:19"

import Blender
from Blender import Draw,BGL,Scene,Object,Window,Lattice,Modifier

# + Title
Title		= 'Lattice Copy - Shape Key'
by              = ' by '
VerWidth	= Draw.GetStringWidth(__version__+ by +__author__)

# + BaseValue
SpcWidth	= 20
BaseHeight	= 20
BtnHeight	= 20

Label	= ['>','Src','Dst',' : ','X Mir','Copy Src to Dst','Exit']
Label_Prompt	= 0
Label_Src	= 1
Label_Dst	= 2
Label_Colon	= 3
Label_XMir	= 4
Label_Execute	= 5
Label_Exit	= 6

BtnWidth=Draw.GetStringWidth(Label[Label_Execute])+SpcWidth
BtnWidthExit=Draw.GetStringWidth(Label[Label_Exit])+SpcWidth
MaxWidth=Draw.GetStringWidth(Title)+BtnWidthExit
StringBtnWidth=MaxWidth-SpcWidth-2


# BaseSceneName
StringBtn=[Draw.Create(Label[Label_Src]),Draw.Create(Label[Label_Dst])]
String_Src	= 0
String_Dst	= 1

s='Lattice.001'
ob=Blender.Scene.GetCurrent().objects.active
if ob!=None:
  if ob.getType()=="Lattice":
    s=ob.name

StringBtn[0].val=s
StringBtn[1].val='Lattice'


Event_None	= 0
Event_Src	= 1
Event_Dst	= 2
Event_SrcMir	= 3
Event_DstMir	= 4

Event_ReDraw	= 10
Event_Execute	= 11
Event_Exit	= 12


def DrawGui():
    global StringBtn
    # --- Init Screen ---
    BGL.glClearColor(0.6, 0.6, 0.6, 0.0)
    BGL.glClear(Blender.BGL.GL_COLOR_BUFFER_BIT)
    BGL.glColor3f(0.1, 0.1, 0.15) # Text Color
    # --- Get Screen Size ---
    size=Blender.BGL.Buffer(Blender.BGL.GL_FLOAT, 4)
    Blender.BGL.glGetFloatv(Blender.BGL.GL_SCISSOR_BOX, size)
    size= size.list
    # FLOAT -> INT
    for s in range(4): size[s]=int(size[s])
    # Base Position
    x=20
    y=size[3]-BaseHeight
    # + Title
    z=y-5
    BGL.glRasterPos2f(x, y)
    Draw.Text(Title)
    
    #   - Mesh Name
    y-=BaseHeight+6+10
    k=x+MaxWidth+2
    for i in range(2):
      Draw.Button (Label[Label_Prompt],Event_Src+i,x,y,SpcWidth,BaseHeight,"")
      StringBtn[i]=Draw.String(Label[Label_Src+i]+Label[Label_Colon],Event_None,x+SpcWidth+2,y,StringBtnWidth,BaseHeight,StringBtn[i].val,255)
      Draw.Button (Label[Label_XMir],Event_SrcMir+i,k,y,BtnWidthExit,BaseHeight,"")
      y-=BaseHeight+4
    
    #   - Execute
    y-=BaseHeight
    #k=x+MaxWidth-BtnWidth
    Draw.Button (Label[Label_Execute],Event_Execute,x+MaxWidth+2+BtnWidthExit-BtnWidth,y,BtnWidth,BaseHeight,"")
    #   - Exit
    Draw.Button (Label[Label_Exit],Event_Exit,k,z,BtnWidthExit,BaseHeight,"")
    # + Version
    y-=14
    BGL.glRasterPos2f(x+MaxWidth-VerWidth, y)
    Draw.Text(__version__+by+__author__)

# + V[̃j[
def SelectLatticeMenu(idx):
    global StringBtn
    
    # + I{[̎W
    NameList=[]
    for ob in Blender.Object.GetSelected():
      if ob.getType()=="Lattice":
        NameList.append(ob.name)
    work=''
    for i,s in enumerate(NameList):
	work+='| %s %%x%d'%(s,i)
    i=Draw.PupMenu(work)
    if i!=-1:
      StringBtn[idx].val=NameList[i]
      Draw.Register(DrawGui, KeyEvent, ButtonEvent)

# 2007.08.20(Mon) 01:42
#   - Src -> Dst ɍWf[^Rs[ăVFCvɋL^
#   - Base⑼̃L[ ɃVFCvƂċL^ꍇ́AKpL[ҏWԂɂĂ
#     IPO Editor  Rs[L[NbN΂悢
#     Rs[ATab ŕҏW𔲂邱ƂœKp
def LatticeCopyShapeKey():
  Src = Blender.Object.Get(StringBtn[String_Src].val)
  Dst = Blender.Object.Get(StringBtn[String_Dst].val)
  
  SrcDat = Src.getData()
  DstDat = Dst.getData()
  x,y,z=SrcDat.getPartitions()
  for i in range(x*y*z):
    v = SrcDat.getPoint(i)
    DstDat.setPoint(i,v)
  
  Dst.insertShapeKey()
  
  Blender.Redraw()

# X ̂ݔ] 2007.08.22(Wed) 02:33
def LatticeMirCopyShapeKey(idx):
  Src = Blender.Object.Get(StringBtn[idx].val)
  SrcDat = Src.getData()
  dx,dy,dz=SrcDat.getPartitions()
  k=dx*dy
  vDic={}
  
  # collect point
  for z in range(dz):
    for y in range(dy):
      ix=z*k+y*dx+dx		# ʈʒuɂCfbNX
      for x in range(dx) :
	ix-=1
        v = SrcDat.getPoint(ix)	# ʈʒuɂW擾
	v[0]=-v[0]		# X ]
	vDic[z*k+y*dx+x]=v	# W
  # regist point
  for v in vDic.iteritems():
    SrcDat.setPoint(v[0],v[1])
  # regist shape
  Src.insertShapeKey()
  Blender.Redraw()

def ButtonEvent(evt):
    if (evt==Event_Execute)			: LatticeCopyShapeKey()
    elif evt in [Event_Src,Event_Dst]		: SelectLatticeMenu(evt-Event_Src)
    elif evt in [Event_SrcMir,Event_DstMir]	: LatticeMirCopyShapeKey(evt-Event_SrcMir)
    elif (evt==Event_Exit)			: Draw.Exit()

def KeyEvent(evt, val):
    # val: 1=KeyDown 0=KeyUp
    if (not val) :
        return
    if evt in [Draw.ESCKEY, Draw.QKEY]:
        Draw.Exit()

Draw.Register(DrawGui, KeyEvent, ButtonEvent)
